
/* All conditionals taken outside of loop and loop replicated, if Cyc == 2. */
/* This file contains all the proceedures for each instance of hh.mat loop.*/
/* Cyc (i,j) loops unwrapped for speed, if Cyc == 1 | 2. */
/*jcr24jul90*/

/* jcr13jul92 qemhb copied from emhb.c and modified for quad prec. option*/
/* jcr17jul92 removed interpolation, was not accurate for small, low freq*/

#include "local.h"
#include <math.h>
#include <stdio.h>  /*For NULL definition*/
#include "em.typ"
#include "hharray.h"
#include "son.h"

/*Global variables for hh array load*/
extern Rtyp ff_re,ff_im;
extern int Capm,Capn,Capm2,Capn2;
extern int loss,xsym;
extern int mo_odd,no_odd;
extern struct qhharray qhh;
extern int gx,gy;  /* = 1 for cos, = 0 for sin */
extern void (*ffp)();  /*pointer to function to do ff term, e.g., ff*/
extern int *ni0,*mi0;
extern RRtyp *qhre,*qhim,*qhrez,*qhimz;

qhlp15c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && no_odd && gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp15c2*/

qhlp7c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && no_odd && gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp7c2*/

qhlp11c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /*mo_odd && !no_odd && gx && gy*/

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp11c2*/

qhlp3c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && !no_odd && gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp3c2*/

qhlp13c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp13c2*/

qhlp5c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp5c2*/

qhlp9c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && !no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp9c2*/

qhlp1c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && !no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi += ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp1c2*/

qhlp14c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp14c2*/

qhlp6c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp6c2*/

qhlp10c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && !no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp10c2*/

qhlp2c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && !no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi += ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp2c2*/

qhlp12c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp12c2*/

qhlp4c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi += ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp4c2*/

qhlp8c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* mo_odd && !no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi += ff_im;
      ffp( Capm-m, Capn-n );  xi -= ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi += ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi += ff_im;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp8c2*/

qhlp0c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi;
  /* !mo_odd && !no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;
      ffp( Capm-m, n );  xi -= ff_im;
      ffp( Capm-m, Capn-n );  xi += ff_im;
      ffp( m, Capn-n );  xi -= ff_im;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;
      ffp( 2*Capm-m, n );  xi -= ff_im;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;
      ffp( Capm+m, Capn-n );  xi -= ff_im;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;
      ffp( Capm-m, Capn+n );  xi -= ff_im;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;
      ffp( m, 2*Capn-n );  xi -= ff_im;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++) *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
  }
} /*qhlp0c2*/

qhlp31c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /*loss &&  mo_odd && no_odd && gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp31c2*/

qhlp23c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && no_odd && gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp23c2*/

qhlp27c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /*mo_odd && !no_odd && gx && gy*/

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp27c2*/

qhlp19c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && !no_odd && gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp19c2*/

qhlp29c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* mo_odd && no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp29c2*/

qhlp21c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp21c2*/

qhlp25c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* mo_odd && !no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp25c2*/

qhlp17c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && !no_odd && !gx && gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp17c2*/

qhlp30c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* mo_odd && no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp30c2*/

qhlp22c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp22c2*/

qhlp26c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* mo_odd && !no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp26c2*/

qhlp18c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  Rtyp xi,xr;
  /* !mo_odd && !no_odd && gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp18c2*/

qhlp28c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* mo_odd && no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp28c2*/

qhlp20c2(m0,m1,n0,n1) int m0,m1,n0,n1;
/*************************************************************/
/* Load the hh.mat for special case.                         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr26jul90 */ 
{ int ni,mi,i,j,m,n;
  RRtyp xi,xr;
  /* !mo_odd && no_odd && !gx && !gy */

  for (ni=n0,n=1; ni<n1; ni++,n=xsym+( (ni)<<xsym ))
  { *qhre = *qhrez = *qhim = *qhimz = 0.0;
    for (mi=m0; (m = mi)<m1; mi++)
    { xi=0.0;  xr=0.0;
      /* old i=0, j=0 */
      ffp( m, n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=0 */
      ffp( Capm+m, n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn-n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm+m, Capn-n );  xi += ff_im;  xr += ff_re;

      /* old i=1, j=1 */
      ffp( Capm+m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( 2*Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( 2*Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( Capm+m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /* old i=0, j=1 */
      ffp( m, Capn+n );  xi -= ff_im;  xr -= ff_re;
      ffp( Capm-m, Capn+n );  xi += ff_im;  xr += ff_re;
      ffp( Capm-m, 2*Capn-n );  xi += ff_im;  xr += ff_re;
      ffp( m, 2*Capn-n );  xi -= ff_im;  xr -= ff_re;

      /*The 0.25 factor is from sin(a)cos(b) = 0.5( * ) twice*/
      *(qhim+m) = 0.25 * xi;  *(qhre+m) = 0.25 * xr;
    }
    /*Do the imag. FFT and store in hh.mat*/
    qcs_fft(qhim,gx,mo_odd,0,Capm);
    /*Do the real FFT*/
    qcs_fft(qhre,gx,mo_odd,0,Capm);
    for (i=0; i<qhh.m; i++)
    { *(qhh.mat_im + qhh.n * i + ni) = *(qhim+i);
      *(qhh.mat_re + qhh.n * i + ni) = *(qhre+i);
    }
  }
} /*qhlp20c2*/
